"""
Contains common lists and dictionaries for use in the package.
"""

import pandas as pd

# Final columns in order
final_col_dict = {
    'Pseudonym': 0,
    'SubmittingCentre': 1,
    'Hospital': 2,
    'Age': 3,
    'Ethnicity': 4,
    'Sex': 5,
    'Smoking status': 6,
    'Pack year history': 7,
    'PMH hypertension': 8,
    'PMH h1pertension': 9,
    'PMH CVS disease': 10,
    'PMH diabetes mellitus type II': 11,
    'PMH diabetes mellitus TYPE I': 12,
    'PMH diabetes mellitus TYPE II': 13,
    'PMH Lung disease': 14,
    'PMH CKD': 15,
    'If CKD, stage': 16,
    'Current ACEi use': 17,
    'Current Angiotension receptor blocker use': 18,
    'Current NSAID used': 19,
    'Date of admission': 20,
    'Duration of symptoms': 21,
    'Respiratory rate on admission': 22,
    'Heart rate on admission': 23,
    'O2 saturation': 24,
    'PaO2': 25,
    'FiO2': 26,
    'Any supplemental oxygen: FiO2': 27,
    'Systolic BP': 28,
    'Diastolic BP': 29,
    'Temperature on admission': 30,
    'NEWS2 score on arrival': 31,
    'WCC on admission': 32,
    'Lymphocyte count on admission': 33,
    'Platelet count on admission': 34,
    'CRP on admission': 35,
    'D-dimer on admission': 36,
    'Fibrinogen  if d-dimer not performed': 37,
    'Ferritin': 38,
    'Ferritin 2': 39,
    'Urea on admission': 40,
    'Creatinine on admission': 41,
    'Troponin I': 42,
    'Troponin T': 43,
    'Date of acquisition of 1st RT-PCR': 44,
    'Date of result of 1st RT-PCR': 45,
    '1st RT-PCR result': 46,
    'Date of acquisition of 2nd RT-PCR': 47,
    'Date of result of 2nd RT-PCR': 48,
    '2nd RT-PCR result': 49,
    'Final COVID Status': 50,
    'Date of Positive Covid Swab': 51,
    'Date of 1st CXR': 52,
    'COVID CODE': 53,
    'CXR severity': 54,
    'Date of 2nd CXR': 55,
    'COVID CODE 2': 56,
    'CXR severity 3': 57,
    'ITU admission': 58,
    'Date of ITU admission': 59,
    'APACHE score on ITU arrival': 60,
    'Intubation': 61,
    'Date of intubation': 62,
    'Death': 63,
    'Date of death': 64,
    'Date last known alive': 65,
    'OtherDataSources': 66,
    'SwabDate': 67,
    'SwabDates': 68,
    'SwabStatus': 69,
    'DateDataReceived': 70,
    'hospital': 71,
    'age': 72,
    'ethnicity': 73,
    'sex': 74,
    'smoking_status': 75,
    'pack_year_history': 76,
    'pmh_hypertension': 77,
    'pmh_cvs_disease': 78,
    'pmh_cvs_disease_info': 79,
    'pmh_diabetes_mellitus_type_2': 80,
    'pmh_lung_disease': 81,
    'pmh_lung_disease_info': 82,
    'pmh_ckd': 83,
    'if_ckd_stage': 84,
    'current_acei_use': 85,
    'current_angiotension_receptor_blocker_use': 86,
    'current_nsaid_used': 87,
    'date_of_admission': 88,
    'duration_of_symptoms': 89,
    'respiratory_rate_on_admission': 90,
    'heart_rate_on_admission': 91,
    'pao2_gas': 92,
    'spo2_saturation': 93,
    'pao2_imputed': 94,
    'spo2_imputed': 95,
    'fio2': 96,
    'pf_ratio': 97,
    'systolic_bp': 98,
    'diastolic_bp': 99,
    'temperature_on_admission': 100,
    'news2_score_on_arrival': 101,
    'calculated_minimum_news2': 102,
    'wcc_on_admission': 103,
    'lymphocyte_count_on_admission': 104,
    'platelet_count_on_admission': 105,
    'crp_on_admission': 106,
    'd-dimer_on_admission': 107,
    'fibrinogen__if_d-dimer_not_performed': 108,
    'ferritin': 109,
    'urea_on_admission': 110,
    'creatinine_on_admission': 111,
    'troponin_i': 112,
    'troponin_t': 113,
    'date_of_acquisition_of_1st_rt-pcr': 114,
    'date_of_result_of_1st_rt-pcr': 115,
    '1st_rt-pcr_result': 116,
    'date_of_acquisition_of_2nd_rt-pcr': 117,
    'date_of_result_of_2nd_rt-pcr': 118,
    '2nd_rt-pcr_result': 119,
    'negative_swab_date': 120,
    'latest_swab_date': 121,
    'final_covid_status': 122,
    'date_of_positive_covid_swab': 123,
    'date_of_1st_cxr': 124,
    'covid_code': 125,
    'cxr_severity': 126,
    'date_of_2nd_cxr': 127,
    'covid_code_2': 128,
    'cxr_severity_2': 129,
    'itu_admission': 130,
    'date_of_itu_admission': 131,
    'apache_score_on_itu_arrival': 132,
    'intubation': 133,
    'date_of_intubation': 134,
    'death': 135,
    'date_of_death': 136,
    'date_last_known_alive': 137,
    'swabdates': 138,
    'pao2': 139,
    'filename_covid_status': 140,
    'filename_earliest_date': 141,
    'filename_latest_date': 142,
    'sex_b4dcm': 143,
    'age_b4dcm': 144,
    'xclean_id': 145,
}

# Original columns
original_cols = [
    'Hospital',
    'Age',
    'Ethnicity',
    'Sex',
    'Smoking status',
    'Pack year history',
    'PMH hypertension',
    'PMH h1pertension',
    'PMH CVS disease',
    'PMH diabetes mellitus type II',
    'PMH diabetes mellitus TYPE I',
    'PMH diabetes mellitus TYPE II',
    'PMH Lung disease',
    'PMH CKD',
    'If CKD, stage',
    'Current ACEi use',
    'Current Angiotension receptor blocker use',
    'Current NSAID used',
    'Date of admission',
    'Duration of symptoms',
    'Respiratory rate on admission',
    'Heart rate on admission',
    'O2 saturation',
    'PaO2',
    'FiO2',
    'Any supplemental oxygen: FiO2',
    'Systolic BP',
    'Diastolic BP',
    'Temperature on admission',
    'NEWS2 score on arrival',
    'WCC on admission',
    'Lymphocyte count on admission',
    'Platelet count on admission',
    'CRP on admission',
    'D-dimer on admission',
    'Fibrinogen  if d-dimer not performed',
    'Ferritin',
    'Ferritin 2',
    'Urea on admission',
    'Creatinine on admission',
    'Troponin I',
    'Troponin T',
    'Date of acquisition of 1st RT-PCR',
    'Date of result of 1st RT-PCR',
    '1st RT-PCR result',
    'Date of acquisition of 2nd RT-PCR',
    'Date of result of 2nd RT-PCR',
    '2nd RT-PCR result',
    'Final COVID Status',
    'Date of Positive Covid Swab',
    'Date of 1st CXR',
    'COVID CODE',
    'CXR severity',
    'Date of 2nd CXR',
    'COVID CODE 2',
    'CXR severity 3',
    'ITU admission',
    'Date of ITU admission',
    'APACHE score on ITU arrival',
    'Intubation',
    'Date of intubation',
    'Death',
    'Date of death',
    'Date last known alive',
    'OtherDataSources',
    'SwabDate',
    'SwabDates',
    'SwabStatus',
    'DateDataReceived',
]

# Columns submitted by GEH in submission order
geh_submission_columns = [
    'SubmittingCentre',
    'Hospital',
    'Age',
    'Ethnicity',
    'Sex',
    'Smoking status',
    'Pack year history',
    'PMH hypertension',
    'PMH CVS disease',
    'PMH diabetes mellitus type II',
    'PMH Lung disease',
    'PMH CKD',
    'If CKD, stage',
    'Current ACEi use',
    'Current Angiotension receptor blocker use',
    'Current NSAID used',
    'Date of admission',
    'Duration of symptoms',
    'Respiratory rate on admission',
    'Heart rate on admission',
    'O2 saturation',
    'PaO2',
    'FiO2',
    'Any supplemental oxygen: FiO2',
    'Systolic BP',
    'Diastolic BP',
    'Temperature on admission',
    'NEWS2 score on arrival',
    'WCC on admission',
    'Lymphocyte count on admission',
    'Platelet count on admission',
    'CRP on admission',
    'D-dimer on admission',
    'Fibrinogen  if d-dimer not performed',
    'Ferritin',
    'Urea on admission',
    'Creatinine on admission',
    'Troponin I',
    'Troponin T',
    'Date of acquisition of 1st RT-PCR',
    'Date of result of 1st RT-PCR',
    '1st RT-PCR result',
    'Date of acquisition of 2nd RT-PCR',
    'Date of result of 2nd RT-PCR',
    '2nd RT-PCR result',
    'Final COVID Status',
    'Date of Positive Covid Swab',
    'Date of 1st CXR',
    'COVID CODE',
    'CXR severity',
    'Date of 2nd CXR',
    'COVID CODE 2',
    'CXR severity 3',
    'ITU admission',
    'Date of ITU admission',
    'APACHE score on ITU arrival',
    'Intubation',
    'Date of intubation',
    'Death',
    'Date of death',
    'Date last known alive',
    'DateDataReceived',
]

# Base cleaned columns
cleaned_base = [
    'Pseudonym',
    'SubmittingCentre',
    'hospital',
    'age',
    'ethnicity',
    'sex',
    'smoking_status',
    'pack_year_history',
    'pmh_hypertension',
    'pmh_cvs_disease',
    'pmh_diabetes_mellitus_type_2',
    'pmh_lung_disease',
    'pmh_ckd',
    'if_ckd_stage',
    'current_acei_use',
    'current_angiotension_receptor_blocker_use',
    'current_nsaid_used',
    'date_of_admission',
    'duration_of_symptoms',
    'respiratory_rate_on_admission',
    'heart_rate_on_admission',
    'fio2',
    'systolic_bp',
    'diastolic_bp',
    'temperature_on_admission',
    'news2_score_on_arrival',
    'calculated_minimum_news2',
    'wcc_on_admission',
    'lymphocyte_count_on_admission',
    'platelet_count_on_admission',
    'crp_on_admission',
    'd-dimer_on_admission',
    'fibrinogen__if_d-dimer_not_performed',
    'ferritin',
    'urea_on_admission',
    'creatinine_on_admission',
    'troponin_i',
    'troponin_t',
    'date_of_acquisition_of_1st_rt-pcr',
    'date_of_result_of_1st_rt-pcr',
    '1st_rt-pcr_result',
    'date_of_acquisition_of_2nd_rt-pcr',
    'date_of_result_of_2nd_rt-pcr',
    '2nd_rt-pcr_result',
    'negative_swab_date',
    'latest_swab_date',
    'final_covid_status',
    'date_of_positive_covid_swab',
    'date_of_1st_cxr',
    'covid_code',
    'cxr_severity',
    'date_of_2nd_cxr',
    'covid_code_2',
    'cxr_severity_2',
    'itu_admission',
    'date_of_itu_admission',
    'apache_score_on_itu_arrival',
    'intubation',
    'date_of_intubation',
    'death',
    'date_of_death',
    'date_last_known_alive',
    'filename_covid_status',
    'xclean_id',
]

# Oxygen columns
all_o2_cols = [
    'pao2_gas',
    'spo2_saturation',
    'pao2_imputed',
    'spo2_imputed',
    'pf_ratio',
]

# Other columns
other_cols = [
    'pmh_lung_disease_info',
    "pmh_cvs_disease_info",
    'filename_earliest_date',
    'filename_latest_date',
]

# Ethnicity map
_ETHNICITY_MAPPING = {
    "A": "White",
    "B": "White",
    "C": "White",
    "C2": "White",
    "C3": "White",
    "CA": "White",
    "CB": "White",
    "CC": "White",
    "CD": "White",
    "CE": "White",
    "CF": "White",
    "CG": "White",
    "CH": "White",
    "CJ": "White",
    "CK": "White",
    "CL": "White",
    "CM": "White",
    "CN": "White",
    "CP": "White",
    "CQ": "White",
    "CR": "White",
    "CS": "White",
    "CT": "White",
    "CU": "White",
    "CV": "White",
    "CW": "White",
    "CX": "White",
    "CY": "White",
    "D": "Multiple",
    "E": "Multiple",
    "F": "Multiple",
    "G": "Multiple",
    "GA": "Multiple",
    "GB": "Multiple",
    "GC": "Multiple",
    "GD": "Multiple",
    "GE": "Multiple",
    "GF": "Multiple",
    "H": "Asian",
    "J": "Asian",
    "K": "Asian",
    "L": "Asian",
    "LA": "Asian",
    "LB": "Asian",
    "LC": "Asian",
    "LD": "Asian",
    "LE": "Asian",
    "LF": "Asian",
    "LG": "Asian",
    "LH": "Asian",
    "LJ": "Asian",
    "LK": "Asian",
    "M": "Black",
    "N": "Black",
    "P": "Black",
    "PA": "Black",
    "PB": "Black",
    "PC": "Black",
    "PD": "Black",
    "PE": "Black",
    "R": "Asian",
    "S": "Other",
    "SA": "Other",
    "SB": "Other",
    "SC": "Other",
    "SD": "Other",
    "SE": "Other",
    "Indian": "Asian",
    "Pakistani": "Asian",
    "Chinese": "Asian",
    "Caribbean": "Black",
    "African": "Black",
    "Any other ethnic group": "Other",
    "Any other Black background": "Black",
    "Any other Asian background": "Asian",
}

# Sex map
_SEX_MAPPING = {"1": "M", "0": "F", "2": "Unknown", "3": "Unknown"}

# fio2 mapping
values_to_percentage = {
    "0": "21",
    "0.5": "23",
    "1": "25",
    "2": "29",
    "3": "33",
    "4": "37",
    "5": "41",
    "6": "45",
    "7": "41",
    "8": "47",
    "9": "53",
    "10": "60",
    "11": "80",
    "12": "85",
    "13": "90",
    "14": "95",
    "15": "100",
    "blue": "24",
    "white": "28",
    "orange": "31",
    "yellow": "35",
    "red": "40",
    "green": "60",
}

# Values at which to clip numeric values
clipping_dict = {
    "temperature_on_admission": [25, 45, 'float'],
    "heart_rate_on_admission": [0, 250, 'integer'],
    "respiratory_rate_on_admission": [0, 100, 'integer'],
    "systolic_bp": [0, 300, 'integer'],
    "diastolic_bp": [10, 250, 'integer'],  # There is one diastolic BP of 1...
    "wcc_on_admission": [0, 500, 'float'],
    "lymphocyte_count_on_admission": [0, 500, 'float'],
    "platelet_count_on_admission": [0, 1000, 'float'],
    "d-dimer_on_admission": [None, None, 'integer'],
    "fibrinogen__if_d-dimer_not_performed": [0, None, 'float'],
    "creatinine_on_admission": [30, 6000, 'integer'],
    "urea_on_admission": [0, 100, 'float'],
    "news2_score_on_arrival": [0, 20, 'integer'],
    "apache_score_on_itu_arrival": [0, 71, 'integer'],
    "crp_on_admission": [None, 1000, 'float'],
}

# units of results provided for d-dimer by centre
ddimer_units = {
    'Sheffield Teaching Hospitals NHS Foundation Trust': 'ng/mL FEU',
    'Sheffield Childrens NHS Foundation Trust': 'ng/mL FEU',
    'Sandwell and West Birmingham Hospitals NHS Trust': 'μg/mL FEU',
    'Royal United Hospitals Bath NHS Foundation Trust': 'ng/mL FEU',
    'Imperial College Healthcare NHS Trust': 'mg/L FEU',
    'University Hospitals of Leicester NHS Trust': 'μg/mL FEU',
    'London North West University Healthcare NHS Trust': 'ng/mL FEU',
    'Ashford and St Peters Hospitals NHS Foundation Trust': 'ng/mL FEU',
    'Taunton and Somerset NHS Foundation Trust': 'μg/mL FEU',
    'Royal Cornwall Hospitals NHS Trust': 'ng/mL FEU',
    'Betsi Cadwaladr University Health Board': 'ng/mL FEU',
    'Liverpool Heart and Chest NHS Foundation Trust': 'ng/mL FEU',
    'Cwm Taf Morgannwg University Health Board': 'ng/mL FEU',
    'George Eliot Hospital NHS Trust': 'μg/mL FEU',
    'Hampshire Hospitals NHS Foundation Trust': 'μg/mL FEU',
    'Norfolk and Norwich University Hospitals NHS Foundation Trust': 'μg/mL FEU',
    'West Suffolk NHS Foundation Trust': 'ng/mL FEU',
    'Brighton and Sussex University Hospitals NHS Trust': 'μg/mL FEU',
    'Oxford University Hospitals NHS Foundation Trust': 'μg/mL FEU',
}

# d-dimer unit conversion factors
dd_conversion_factors = {
    'ng/mL FEU': 1,
    'mg/L FEU': 1000,
    'μg/mL FEU': 1000,
    'ng/mL DDU': 2,
    'mg/L DDU': 1000,
    'μg/mL DDU': 2000,
}

# standard clinical columns to be cleaned as per nccid:
clinical_columns = (
    "Duration of symptoms",
    "Respiratory rate on admission",
    "Heart rate on admission",
    "NEWS2 score on arrival",
    "APACHE score on ITU arrival",
    "PaO2",
    "Creatinine on admission",
    "D-dimer on admission",  # units vary between sites
    "Fibrinogen  if d-dimer not performed",
    "WCC on admission",
    "Lymphocyte count on admission",
    "Platelet count on admission",
    "CRP on admission",  # mg/L large variance expected
    "Urea on admission",  # units vary ng/ml vs mmol/L
    "O2 saturation",
    "Temperature on admission",
    "Ferritin",  # most sites use ug/L
    "Troponin I",  # sites vary between ng/L and ng/ml
    "Troponin T",  # not widely used by sites
)

# Hospital abbreviation to hospital name
_HOSPITAL_MAPPING = {
    'HH': 'Hammersmith Hospital',
    'SMH': "St. Mary's Hospital",
    'CXH': 'Charing Cross Hospital',
    'MPH': 'Musgrove Park Hospital',
    'SWBH': 'Unknown',
    'RCHT': 'Unknown',
    'BCUHB': 'Unknown',
    'RUH Bath': 'Royal United Hospital',
    'EAL': 'Ealing Hospital',
    'George Eliot Hospital NHS Trust ': 'George Eliot Hospital',
    'BNH': 'Basingstoke and North Hampshire Hospital',
    'RHCH': 'Royal Hampshire County Hospital',
    'BSUH': 'Unknown',
    'NNUH': 'Norfolk & Norwich University Hospital',
    'NPH': 'Northwick Park Hospital',
    'PCH': 'Prince Charles Hospital',
    'RGH': 'Royal Glamorgan Hospital',
    'RGL': 'Royal Glamorgan Hospital',
    'YCC': 'Ysbyty Cwm Cynon',
    'PRH': 'Princess Royal Hospital',
    'RSCH': 'RSCH',
    'LTHT': 'Unknown',
    'Sheffield': 'Unknown',
    'Oxford University Hospitals NHS FT': 'Unknown',
    'West Suffolk NHS Foundation Trust': 'West Suffolk Hospital',
    'Ashford and St Peters NHS Foundation Trust': "Ashford and St Peter's Hospital",
    'George Eliot Hospital NHS Trust': 'George Eliot Hospital',
}

# Hospital names for those with missing values
_NO_HOSP_MAP = {
    "Ashford and St Peters Hospitals NHS Foundation Trust": "Ashford and St Peter's Hospital",
    "Betsi Cadwaladr University Health Board": "Unknown",
    "Brighton and Sussex University Hospitals NHS Trust": "Unknown",
    "Cambridge University Hospitals NHS Foundation Trust": "Addenbrooke's Hospital",
    "George Eliot Hospital NHS Trust": "George Eliot Hospital",
    "Leeds Teaching Hospitals NHS Trust": "Unknown",
    "Liverpool Heart and Chest NHS Foundation Trust": "Liverpool Heart and Chest Hospital",
    "Norfolk and Norwich University Hospitals NHS Foundation Trust": "Norfolk and Norwich University Hospital",
    "Oxford University Hospitals NHS Foundation Trust": "Unknown",
    "Royal Cornwall Hospitals NHS Trust": "Unknown",
    "Royal Surrey NHS Foundation Trust": "Royal Sussex County Hospital",
    "Royal United Hospitals Bath NHS Foundation Trust": "Royal United Hospital",
    "Sandwell and West Birmingham Hospitals NHS Trust": "Unknown",
    "Sheffield Childrens NHS Foundation Trust": "Sheffield Children's Hospital",
    "Sheffield Teaching Hospitals NHS Foundation Trust": "Unknown",
    "St Georges University Hospitals NHS Foundation Trust": "St George's Hospital",
    "Taunton and Somerset NHS Foundation Trust": "Musgrove Park Hospital",
    "The Walton Centre NHS Foundation Trust": "The Walton Centre",
    "University Hospitals of Leicester NHS Trust": "Unknown",
    "West Suffolk NHS Foundation Trust": "West Suffolk Hospital",
    "Hampshire Hospitals NHS Foundation Trust": "Unknown",
    'Imperial College Healthcare NHS Trust': 'Unknown',
    'London North West University Healthcare NHS Trust': 'Unknown',
    'Cwm Taf Morgannwg University Health Board': 'Unknown',
    'University Hospitals Bristol NHS Foundation Trust': 'Unknown',
}

# Submitting Centres in the development data
dev_submitting_centres = [
    'Hampshire Hospitals NHS Foundation Trust',
    'Cambridge University Hospitals NHS Foundation Trust',
    'West Suffolk NHS Foundation Trust',
    'George Eliot Hospital NHS Trust',
    'Royal United Hospitals Bath NHS Foundation Trust',
    'Betsi Cadwaladr University Health Board',
    'Ashford and St Peters Hospitals NHS Foundation Trust',
    'Brighton and Sussex University Hospitals NHS Trust',
    'Norfolk and Norwich University Hospitals NHS Foundation Trust',
    'London North West University Healthcare NHS Trust',
    'Royal Cornwall Hospitals NHS Trust',
    'Taunton and Somerset NHS Foundation Trust',
    'Imperial College Healthcare NHS Trust',
    'Sandwell and West Birmingham Hospitals NHS Trust',
    'Liverpool Heart and Chest NHS Foundation Trust',
    'Cwm Taf Morgannwg University Health Board',
    'Sheffield Childrens NHS Foundation Trust',
    'Sheffield Teaching Hospitals NHS Foundation Trust',
    'University Hospitals of Leicester NHS Trust',
    'Oxford University Hospitals NHS Foundation Trust',
    'Royal Surrey NHS Foundation Trust',
    'The Walton Centre NHS Foundation Trust',
    'University Hospitals Bristol NHS Foundation Trust',
    'St Georges University Hospitals NHS Foundation Trust',
    'Leeds Teaching Hospitals NHS Trust',
]

# Date columns
date_cols = [
    'date_of_positive_covid_swab',
    'date_of_acquisition_of_1st_rt-pcr',
    'date_of_acquisition_of_2nd_rt-pcr',
    'date_of_result_of_1st_rt-pcr',
    'date_of_result_of_2nd_rt-pcr',
    'date_of_admission',
    'date_of_itu_admission',
    'date_of_intubation',
    'date_of_1st_cxr',
    'date_of_2nd_cxr',
    'date_last_known_alive',
    'date_of_death',
    'negative_swab_date',
    'latest_swab_date'
]

# Types to read columns in as in final data without cleaned date columns
read_in_types_dict = {
    'Pseudonym': str,
    'SubmittingCentre': str,
    'Hospital': str,
    'Age': str,
    'Ethnicity': str,
    'Sex': str,
    'Smoking status': str,
    'Pack year history': str,
    'PMH hypertension': str,
    'PMH h1pertension': str,
    'PMH CVS disease': str,
    'PMH diabetes mellitus type II': str,
    'PMH diabetes mellitus TYPE I': str,
    'PMH diabetes mellitus TYPE II': str,
    'PMH Lung disease': str,
    'PMH CKD': str,
    'If CKD, stage': str,
    'Current ACEi use': str,
    'Current Angiotension receptor blocker use': str,
    'Current NSAID used': str,
    'Date of admission': str,
    'Duration of symptoms': str,
    'Respiratory rate on admission': str,
    'Heart rate on admission': str,
    'O2 saturation': str,
    'PaO2': str,
    'FiO2': str,
    'Any supplemental oxygen: FiO2': str,
    'Systolic BP': str,
    'Diastolic BP': str,
    'Temperature on admission': str,
    'NEWS2 score on arrival': str,
    'WCC on admission': str,
    'Lymphocyte count on admission': str,
    'Platelet count on admission': str,
    'CRP on admission': str,
    'D-dimer on admission': str,
    'Fibrinogen  if d-dimer not performed': str,
    'Ferritin': str,
    'Ferritin 2': str,
    'Urea on admission': str,
    'Creatinine on admission': str,
    'Troponin I': str,
    'Troponin T': str,
    'Date of acquisition of 1st RT-PCR': str,
    'Date of result of 1st RT-PCR': str,
    '1st RT-PCR result': str,
    'Date of acquisition of 2nd RT-PCR': str,
    'Date of result of 2nd RT-PCR': str,
    '2nd RT-PCR result': str,
    'Final COVID Status': str,
    'Date of Positive Covid Swab': str,
    'Date of 1st CXR': str,
    'COVID CODE': str,
    'CXR severity': str,
    'Date of 2nd CXR': str,
    'COVID CODE 2': str,
    'CXR severity 3': str,
    'ITU admission': str,
    'Date of ITU admission': str,
    'APACHE score on ITU arrival': str,
    'Intubation': str,
    'Date of intubation': str,
    'Death': str,
    'Date of death': str,
    'Date last known alive': str,
    'OtherDataSources': str,
    'SwabDate': str,
    'SwabDates': str,
    'SwabStatus': str,
    'DateDataReceived': str,
    'hospital': str,
    'age': float,
    'ethnicity': str,
    'sex': str,
    'smoking_status': str,
    'pack_year_history': float,
    'pmh_hypertension': str,
    'pmh_cvs_disease': str,
    'pmh_cvs_disease_info': str,
    'pmh_diabetes_mellitus_type_2': str,
    'pmh_lung_disease': str,
    'pmh_lung_disease_info': str,
    'pmh_ckd': str,
    'if_ckd_stage': str,
    'current_acei_use': str,
    'current_angiotension_receptor_blocker_use': str,
    'current_nsaid_used': str,
    'duration_of_symptoms': float,
    'respiratory_rate_on_admission': float,
    'heart_rate_on_admission': float,
    'pao2_gas': float,
    'spo2_saturation': float,
    'pao2_imputed': float,
    'spo2_imputed': float,
    'fio2': float,
    'pf_ratio': float,
    'systolic_bp': float,
    'diastolic_bp': float,
    'temperature_on_admission': float,
    'news2_score_on_arrival': float,
    'calculated_minimum_news2': float,
    'wcc_on_admission': float,
    'lymphocyte_count_on_admission': float,
    'platelet_count_on_admission': float,
    'crp_on_admission': float,
    'd-dimer_on_admission': float,
    'fibrinogen__if_d-dimer_not_performed': float,
    'ferritin': float,
    'urea_on_admission': float,
    'creatinine_on_admission': float,
    'troponin_i': float,
    'troponin_t': float,
    '1st_rt-pcr_result': str,
    '2nd_rt-pcr_result': str,
    'final_covid_status': str,
    'covid_code': str,
    'cxr_severity': str,
    'covid_code_2': str,
    'cxr_severity_2': str,
    'itu_admission': str,
    'apache_score_on_itu_arrival': float,
    'intubation': str,
    'death': str,
    'filename_covid_status': bool,
    'age_b4dcm': float,
    'sex_b4dcm': str,
    # 'date_of_positive_covid_swab': str,
    # 'date_of_acquisition_of_1st_rt-pcr': str,
    # 'date_of_acquisition_of_2nd_rt-pcr': str,
    # 'date_of_result_of_1st_rt-pcr': str,
    # 'date_of_result_of_2nd_rt-pcr': str,
    # 'date_of_admission': str,
    # 'date_of_itu_admission': str,
    # 'date_of_intubation': str,
    # 'date_of_1st_cxr': str,
    # 'date_of_2nd_cxr': str,
    # 'date_last_known_alive': str,
    # 'date_of_death': str,
    # 'negative_swab_date': str,
    # 'latest_swab_date': str,
    'xclean_id': str,
}


